<?php
/*
	Auteur : BestPig
		URL : http://bestpig.fr

	Cr : 7 juin 2009
*/

include 'config.php';

function http_get_cookie($url, $dataPost, $personal_header=null)
{
  $tmp = http_post_cookie($url, $dataPost, $cookie=false, $personal_header);

  preg_match_all("#Set-Cookie: (.*);#", $tmp, $out, PREG_PATTERN_ORDER);
  
  $cookie = '';
  for($i=0;$i<count($out[1]);$i++)
  {
    if ((count($out[1])-1) == $i)
      $cookie.= $out[1][$i];
    else
      $cookie.= $out[1][$i].';';
  }
  return $cookie;
}

function http_post_cookie($url, $dataPost, $cookie=false, $personal_header=null)
{
    global $config;
    //Pour sparer l'host du fichier
    $array = explode("/",str_replace("http://","",preg_replace("/:(\d+)/","",$url)));
    $host = $array[0];
    $file = substr($url, (strpos($url, $array[0])+ strlen($array[0])), strlen($url));

    //Connection au serveyr
    $fichlir = @fsockopen($host, 80, $errno, $errstr, 30);
    if (!$fichlir)
    {
		Return false;
    }
    else
    {
		//Cre le requete HTTP a envoyer
		$out = "POST ".$file." HTTP/1.1\r\n";
		$out .= "Host: ".$host."\r\n";
		$out .= "User-Agent: ".$config['user_agent']."\r\n";
		$out .= "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n";
		$out .= "Accept-Language: fr,fr-fr;q=0.8,en-us;q=0.5,en;q=0.3\r\n";
		$out .= "Accept-Encoding: deflate\r\n";
		$out .= "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n";
		$out .= "Keep-Alive: 300\r\n";
		$out .= "Connection: keep-alive\r\n";

		if (!empty($personal_header))
			$out .= $personal_header;

		if ($cookie != false)
			$out .= "Cookie: ".$cookie."\r\n";
	    $out .= "Content-Type: application/x-www-form-urlencoded\r\n";
	    $out .= "Content-Length: ".strlen($dataPost)."\r\n";
	    $out .= "\r\n";
	    $out .= $dataPost;

		//Envoie la requete
		fwrite($fichlir, $out);

		//Lit le header
		$_response_headers = $_response_keys = array();

		$line = fgets($fichlir, 8192);
    $data = $line;
    
		while (strspn($line, "\r\n") !== strlen($line))
		{
		    @list($name, $value) = explode(':', $line, 2);
		    $name = trim($name);
		    $_response_headers[strtolower($name)][] = trim($value);
		    $_response_keys[strtolower($name)] = $name;
		    $line = fgets($fichlir, 8192);
		    $data.= $line;
    }
    
  }
	@fclose($fichlir);
	return $data;
}

function get_mu_premium($fichieradl)
{
	global $config;
   
	if (!file_exists('config_compte.php'))
		create_cookie();

	include 'config_compte.php';

    //Pour eviter la redirection
    preg_match('#\?d=(.*)#', $fichieradl, $matches);
    $fichieradl = 'http://www.megaupload.com/?d='.$matches[1];

    //Pour sparer l'host et le fichier
    $array = explode("/",str_replace("http://","",preg_replace("/:(\d+)/","",$fichieradl)));
    $host = $array[0];
    $file = substr($fichieradl, (strpos($fichieradl, $array[0])+ strlen($array[0])), strlen($fichieradl));

    //Lit les headers et rcupre le vrai lien
    $fichlir = fsockopen($host, 80, $errno, $errstr, 30);
    if (!$fichlir)
    {
        exit;
    }
    else
    {
        //Cre le requete HTTP a envoyer
        $out = "GET ".$file." HTTP/1.0\r\n";
        $out .= "Host: ".$host."\r\n";
		$out .= "User-Agent: ".$config['user_agent']."\r\n";
        $out .= "Cookie: ".$config['megaupload']['cookie']."\r\n";
        $out .= "\r\n";
               
        //Envoie la requete
        fwrite($fichlir, $out);
         
        //Lit le header
        $_response_headers = $_response_keys = array();
        
        $line = fgets($fichlir, 8192);
        
        while (strspn($line, "\r\n") !== strlen($line))
        {
            @list($name, $value) = explode(':', $line, 2);
            $name = trim($name);
            $_response_headers[strtolower($name)][] = trim($value);
            $_response_keys[strtolower($name)] = $name;
            $line = fgets($fichlir, 8192);
            if (preg_match("#location: http://www([0-9]*)\.megaupload\.com/files/(.*)\r\n#", $line, $out))
            {
                $first_method = 1;
                $url = 'http://www'.$out[1].'.megaupload.com/files/'.$out[2];
            }
        }
        
        if (!isset($url))
        {
            $first_method = 0;
            $data = '';
            //Rcupre la page de megaupload
            while (!feof($fichlir))
            {
                $data.= fread($fichlir, 8192);
            }
                  
            //Rcupre l'url
            preg_match('#(http://www((?!\.\.).)*/files/.*)" #', $data, $matches);
            $url = $matches[1];
	    $url = str_replace('" onclick="', '', $url);
        }

        //On ferme la connection
        fclose($fichlir);
	}
	if (($first_method == 0 && (!preg_match('#'.$config['megaupload']['user'].'#', $data))) || empty($url))
	{
		unlink('config_compte.php');
		return 'Une erreur c\'est produite peut etre que le compte premium n\'est plus valide';
	}else{
		return $url;
	}
}

function create_cookie()
{
	global $config;

	$cookie = http_get_cookie('http://www.megaupload.com/?c=login', 'login=1&redir=1&username='.$config['megaupload']['user'].'&password='.$config['megaupload']['pass'], "Referer: http://www.megaupload.com/?c=login\r\n");

	$config_compte = '<?php
$config[\'megaupload\'][\'cookie\'] = \''.$cookie.'\'
?>';
	$fp = fopen('config_compte.php', 'w');
	fwrite($fp, $config_compte);
	fclose($fp);
	exit();
}
?>
